#include <iom32.h>
#include <inavr.h>
#include <iomacro.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MID_DELAY(Delay) MidDelay((unsigned char)(((unsigned short int)Delay*(unsigned short int)QUATZ_FREQ-(unsigned short int)10)/(unsigned short int)5)) //160  max  8   80  16
#define BIG_DELAY(Delay) BigDelay((unsigned short int)(((long)Delay*(long)QUATZ_FREQ-(long)11)/(long)7)) //57344 k max  8   28672  16

//10  + 5 /
void MidDelay(unsigned char Delay)
{while(Delay>0) Delay--;
};
//11  + 7 /
void BigDelay(unsigned short int Delay)
{while(Delay>0) Delay--;
};

//PORTB7..4 -Data
//PB3 -       
//PB2-RS
//PB1-R/nWR
//PB0-E
void LcdHalfTransRegChar(char cData)//        
{DDRB |= 0xf7;//  
 PORTB &= 0x8;//   
 cData &=0xf0;//   
 PORTB |=cData;//     
 asm("NOP");
// PORTB |=0x01;//E=1 -   
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
// PORTB &=~0x01;//E=0 -   
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18) 
 asm("NOP");
};

char LcdReadBF()//    
{char c,c1;
 DDRB &= 0x0f;//     
 DDRB |= 0x07;//    
 PORTB &= 0x08;// 
 asm ("sbi 0x18,1");//
 asm("NOP");
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 c=PINB;// 
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 c1=PINB;// 
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18)
 c&=0xf0;
 c1=(c1>>4)&0x0f;
 c |= c1;
 DDRB|=0xf7;//   
 asm("NOP");
 return c;
};

void LcdTransRegChar(char cData)//   
{while(LcdReadBF()&0x80);// 
 char c=(cData<<4)&0xf0;
 DDRB |= 0xf7;//  
 PORTB &= 0x8;//   
 cData &=0xf0;//   
 PORTB |=cData;//     
 asm("NOP");
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18) 
 PORTB &=0x0f;
 PORTB |=c;//     
 asm("NOP");
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
// PORTB &=~0x01;//E=0 -   
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18) 
 asm("NOP");
};


void LcdTransmitChar(char cData)//  
{while(LcdReadBF()&0x80);// 
 unsigned char c=(cData<<4)&0xf0;
 DDRB |= 0xf7;//  
 PORTB &= 0x8;//     3
 cData &=0xf0;//   
 PORTB |= cData;//     
 asm ("sbi 0x18,2");//  0x04  PORTB(=0x18) - 
 asm("NOP");
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18) 
 PORTB &=0x0f;
 PORTB |=c;//     
 asm("NOP");
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18) 
 asm("NOP");
};

void LcdSetAdr(unsigned char Adr)//  
{while(LcdReadBF()&0x80);// 
 char c=(Adr<<4)&0xf0;
 Adr |= 0x80;
 Adr &=0xf0;
 DDRB |= 0xf7;//  
 PORTB &= 0x8;//   
 PORTB |= Adr;//     
 asm("NOP");
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18) 
 PORTB &=0x0f;
 PORTB |=c;//     
 asm("NOP");
 asm ("sbi 0x18,0");//  0x01  PORTB(=0x18)
 MID_DELAY(1);
 asm ("cbi 0x18,0");//  0x01  PORTB(=0x18) 
 asm("NOP"); 
}

void InitLCD()//   - 4
{// 30 
  BIG_DELAY(20000);
  BIG_DELAY(12000);
 //Function set
 LcdHalfTransRegChar(0x20);//Func set
 LcdHalfTransRegChar(0x20);//Func set
 LcdHalfTransRegChar(0xc0);//Func set
 MID_DELAY(40);//40 
//Display On/Off
 LcdHalfTransRegChar(0x00);//Func set
 LcdHalfTransRegChar(0xf0);//Disp mode set
 MID_DELAY(40);//40 
//Display Clear 
 LcdHalfTransRegChar(0x00);//Disp Clear
 LcdHalfTransRegChar(0x10);//Disp Clear
 BIG_DELAY(2000);//2 
//Entry mode set
 LcdHalfTransRegChar(0x00);//Entry mode set
 LcdHalfTransRegChar(0x20);//Entry mode set
 MID_DELAY(40);//40 
}
 
