#include <iom32.h>
#include <inavr.h>
#include <iomacro.h>
#include <ctype.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>

__flash const unsigned char  TabWin[128] = { 
0xc8, 0xc9, 0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf, //  
0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, //  
0xd8, 0xd9, 0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf, //  
0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec, 0xed, 0xee, //  
0xef, 0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, //  
0xa2, 0xf7, 0xf8, 0xf9, 0xfa, 0xfb, 0xfc, 0xfd, //   
0xfe, 0xff, 0xe7, 0xe8, 0xe9, 0xea, 0xeb, 0xec, //  
0xb5, 0xee, 0xef, 0xf0, 0xf1, 0xf2, 0xfd, 0xff, //   
0x41, 0xa0, 0x42, 0xa1, 0xe0, 0x45, 0xa3, 0xa4, //  
0xa5, 0xa6, 0x4b, 0xa7, 0x4d, 0x48, 0x4f, 0xa8, //  
0x50, 0x43, 0x54, 0xa9, 0xaa, 0x58, 0xe1, 0xab, //  
0xac, 0xe2, 0xad, 0xae, 0x62, 0xaf, 0xb0, 0xb1, //  
0x61, 0xb2, 0xb3, 0xb4, 0xe3, 0x65, 0xb6, 0xb7, //  
0xb8, 0xb9, 0xba, 0xbb, 0xbc, 0xbd, 0x6f, 0xbe, //  
0x70, 0x63, 0xbf, 0x79, 0xe4, 0x78, 0xe5, 0xc0, //  
0xc1, 0xe6, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, //  
}; 

#define QUATZ_FREQ 8// 15// 

#define F_QUARTZ_FREQ 7.3728
//__delay_cycles(unsigned long int)
#define DelayUs(Delay) __delay_cycles((unsigned long int)(F_QUARTZ_FREQ*(float)Delay+1.0))

#define REF_AVCC 0x40
#define REF_2_56 0xc0

#define TIMER_PERIOD 3686//     F_QUARTZ_FREQ*500 = 0.5 msec
//#define TIMER_BIG_PERIOD 20//  ,   1 
#define BEEP_LENGTH 200

#define FIRST_ADC 0x01//   
#define ADC_NUM_CHAN 4
#define ADC_NUM_CYCLES 32

#ifndef DS_MAX_UNITS
#define DS_MAX_UNITS 4
#endif

#define DS_RESET_TIME0 108 //480 
#define DS_RESET_TIME1 14 //70 
#define DS_RESET_TIME2 92 //410 

#define KEY_STAT 4
//  eeprom
//__eeprom static float dAdcT0Shift=0.0,dAdcT0Mult=1.0;

volatile unsigned short int tim_cnt;//  
volatile unsigned char BeepCnt=0, FlashLedCnt=0;//   FlashLed
//unsigned char TimBigCnt;//     
// ,      
volatile unsigned char Tim_Flg=0,StartCommandFlg=0;

//  

// 
volatile unsigned short int AdcIntData[ADC_NUM_CHAN],AdcOutData[ADC_NUM_CHAN],Glob_AdcOutData[ADC_NUM_CHAN];
volatile unsigned char AdcMultiplex=0;// 
volatile unsigned char FirstAdcBits=1,AdcNumCyclesCnt;
volatile unsigned char AdcCycleFlg=0,AdcOuFlg=0;

// 
volatile unsigned char ButReadCode,ButFlg,ButCnt;

// DS18
volatile unsigned char DsResetState=0,ResetReadyFlg=0,DsResetResult=0;
signed short int DsData[DS_MAX_UNITS];
unsigned char DsNumUnits=0;


/*
//__eeprom__eeprom__eeprom static float ADC_PowerCoeff=0.0253766;//    "PowerInput"
*/

//  
char DString[2][17];

void FlashLed()
{FlashLedCnt=20;
 //asm ("sbi 0x1B,3");//PORTA=0x1B
};

SetBeep()
{BeepCnt = BEEP_LENGTH;// beep
 TCCR1A |= 0x80; // 
}

#define PWM_LEN 100
// PWM
signed short int PwmPow[4];
volatile unsigned char Int1Flg=0,PwmCnt,PwmState;//PwmState -  4  - On/Off  
volatile signed int PwmErr[4],PwmStep[4];
void BrezStart(unsigned char PwmNum)
{PwmStep[PwmNum]=0;
 PwmErr[PwmNum] = (PwmPow[PwmNum]<<1) - PWM_LEN;
};
unsigned char BrezStep()
{unsigned char i,res=0,shift=0x80;
 signed int up;//  
 signed int step,err;//  ;
 for(i=0;i<4;i++)
   {up=PwmPow[i];
    step=PwmStep[i];
    err=PwmErr[i];
  
    step++;//      .
    if(step >= PWM_LEN)
      {//   
       step=0;
       err = (up<<1) - PWM_LEN;
      };
    if(err >= 0)  // 
	  {err += (up-PWM_LEN)<<1;
	   res |= shift;
	  }
    else err += up<<1;

    shift >>= 1;
    PwmStep[i]=step;
    PwmErr[i]=err;
   };
 return res;
};

void PwmSet(PwmState)
{PORTC &=0x0f;
 PORTC |= PwmState&0xf0;
};

#include "RS232.c"

//     INT1
#pragma vector = INT1_vect
__interrupt void Int1_int() //   2 
{Int1Flg=1;
}

//   2 -  Reset
#pragma vector = TIMER2_COMP_vect
__interrupt void Tim2_Comp_int() //   2 
{TCCR2 &=~0x07;//  
 if(!DsResetState) goto end_t2_handle;//   
 //  DsReset DsResetState=0->  
 switch(DsResetState)
     {case 1://  Reset -      DS_RESET_TIME0
              OCR2=DS_RESET_TIME1;
              asm ("cbi 0x11,7");//   
              DsResetState++;
              break;
      case 2: //  Reset -     DS_RESET_TIME1
              OCR2=DS_RESET_TIME1;
              DsResetResult=PIND&0x80;
              DsResetState++;
              break;
      case 3: //  Reset -     DS_RESET_TIME2
              OCR2=DS_RESET_TIME2;
              DsResetState=0;
              ResetReadyFlg=1;
              goto end_t2_handle;//   
     };
 TCNT2=0;//  
 TCCR2 |= 0x03;//  
end_t2_handle:; //   
}


//  
volatile unsigned char KeyCnt=0, KeyStat=0,OldKey=0,KeyFlg=0,OutKey=0;
void KeyDecode(unsigned short int AdcCode)
{unsigned char ButCode;
 if(KeyFlg) return;//  .   .
  //     
 if(AdcCode<255) {ButCode=7; goto end_code;};
 if(AdcCode<598) {ButCode=6; goto end_code;};
 if(AdcCode<725) {ButCode=5; goto end_code;};
 if(AdcCode<794) {ButCode=4; goto end_code;};
 if(AdcCode<836) {ButCode=3; goto end_code;};
 if(AdcCode<866) {ButCode=2; goto end_code;};
 if(AdcCode<951) {ButCode=1; goto end_code;};
 ButCode=0;//  
end_code:;

 if(OldKey==ButCode) KeyCnt++;//    -  
 else {KeyCnt=0;OldKey=ButCode;return;};//     -     
 if(KeyCnt<KEY_STAT) return; // .   
 //  KEY_STAT 
 if(OldKey==0)// 
   {KeyStat=0;
    KeyCnt=0;
    return;
   };
// 
 if(KeyStat!=0)//      .     
   {KeyCnt=0;  
    return;
   };
//   -    
 OutKey=OldKey;
 KeyFlg=1;
 KeyStat=1;
 KeyCnt=0;
};

//    
#pragma vector = TIMER1_OVF_vect
__interrupt void Tim1_Owf_int() //   2 
{//     
 if(Int1Flg)
   {Int1Flg=0;
    PwmCnt++;
    if(PwmCnt & 0x2) 
      {PwmCnt=0;
       PwmSet(BrezStep());
      };
   };
  
//  
 tim_cnt--;
 if(tim_cnt==0)
  {tim_cnt=TIMER_PERIOD;
   if(Tim_Flg!=0xff) Tim_Flg++;
  };// End if(tim_cnt==0)//   

 /*   if(RecTimeoutCnt>0)
     {RecTimeoutCnt--;
      if(RecTimeoutCnt==0)//    
        {//UCSR1A=0;
         RecBufCnt=0;
         NumReceive=0;
        };
    };

 if(FlashLedCnt>0)
  {FlashLedCnt--;
   //if(FlashLedCnt==0) asm ("cbi 0x1B,3");//PORTA=0x1B
  };
 */
 
 //   
 if(BeepCnt)
   {BeepCnt--;
    if(!BeepCnt) TCCR1A &= 0x3f;
   };
 
 //   4-  
 if(AdcCycleFlg)//    
 {unsigned short i;
  //  - 1  
  KeyDecode(AdcIntData[1]);//  
  
  if(!AdcOuFlg)//    
    {if(FirstAdcBits)//    - ,   - 
      {FirstAdcBits=0;//   
       for(i=0;i<ADC_NUM_CHAN;i++) AdcOutData[i]=AdcIntData[i];// 
      }
     else for(i=0;i<ADC_NUM_CHAN;i++) AdcOutData[i]+=AdcIntData[i];// 
     if(AdcNumCyclesCnt>0)//  ADC_NUM_CYCLES 
       {AdcNumCyclesCnt--;//  
        if(AdcNumCyclesCnt==0)//    
         {AdcOuFlg=1;//    
          AdcNumCyclesCnt=ADC_NUM_CYCLES;//  
          FirstAdcBits=1;//    
         };
       };
     AdcCycleFlg=0;//    
     asm("sbi 0x06,6");//   (ADCSRA= 0x06)
    };// End if(!AdcOuFlg);       -   
 };//End if(AdcCycleFlg);      -   
};//End    

//  ADC 
#pragma vector = ADC_vect
__interrupt void ADC_int()
{unsigned char c0,c1;
 if(!AdcCycleFlg)//     
 {c0=ADCL;//  
  c1=ADCH;
  AdcIntData[AdcMultiplex] = (((unsigned short int)c1)<<8) +c0;//    
  AdcMultiplex=(AdcMultiplex+1)&0x03;//  
  ADMUX = REF_AVCC | AdcMultiplex;//  , REF=AVCC
  if(AdcMultiplex==0)  AdcCycleFlg=1;//    -    
                                     //     
  else asm("sbi 0x06,6");//   (ADCSRA= 0x06)
 };//End if(!AdcCycleFlg)       -   
};

#include "LCD_proc.c"
#include "DS18.c"

void PwmSetValue(unsigned char PwmNum, unsigned char PwmValue)
{char EI=SREG&0x80;
 if(PwmValue>100) PwmValue=100;
 if(EI) __disable_interrupt();// 
 PwmPow[PwmNum]=PwmValue;
 BrezStart(PwmNum);
 if(EI) __enable_interrupt();// 
};

unsigned char DsTimReset()
{if(!ResetReadyFlg && !DsResetState)//Reset    - 
  {OCR2=DS_RESET_TIME0;
   TCNT2=0;//  
   TCCR2 |= 0x03;//  
   asm ("cbi 0x12,7");//  0 7  PORTD
   asm ("sbi 0x11,7");//   
   DsResetState=1;
  };
 while(!ResetReadyFlg);
 ResetReadyFlg=0;
 return DsResetResult;
};

//  DString[][]      
void RefreshLCD()
{char i;
 unsigned char c;
 LcdSetAdr(0);
 for(i=0;i<16;i++)
   {c=DString[0][i];   
    if(c>=0x80) { c-=0x80; c=TabWin[c];};
    LcdTransmitChar(c);
   };
 LcdSetAdr(0x40); 
 for(i=0;i<16;i++)
   {c=DString[1][i];   
    if(c>=0x80) { c-=0x80; c=TabWin[c];};
    LcdTransmitChar(c);
   };
};

// ***************** MAIN ************************
void main()
{unsigned char i,TmpFlg=0,TmpKey=0,GblOutKey=0,ShowState=0,ShowCnt=0,PwmTestVal=0;
//     
 PORTA=0x00;
 DDRA=0x00;//   -  

 PORTB=0x00;// 0x80 -    -  
 DDRB=0xff;//   -  LCD

 //PC[7..2]-7..4 -   , 3..2 - , 1..0 - I2C
 PORTC=0;
 DDRC=0xff;

 //PD0,PD1 - RXD  TXD; //PD2- INT ; //PD3- INT-PwmInt;
 //PD4 -     //PD5 -  //PD6 -//PD7-Dallas
 PORTD=0x00;
 DDRD=0xf2;

 // ADC init
 //   7.3728  1/64  CLK=115.2 .
//   - 7.5    
 ADCSRA=0x8e;//ADC enable,Start-,AutoTrig ,Int  , ,ADPS[2..0]=8 - -64
 SFIOR &=0x0f;//ADTS[2..0]=0 (   )
 AdcMultiplex=0;// 
 ADMUX=REF_AVCC | AdcMultiplex;//(Ref=AVCC),ADLAR=0,MUX[4..0]=0(  ADC, SingleEnded);

 // ********* Timer 0 init -   
 // =  /256=28.8(7)
 //   ,    
 TCCR0=0x48 //WGM1[3]=1 WGM0[6]=1 FastPwm;
      | 0x20  //COM01[5]=1  COM00[4]=0    OC clear on OCR0;
      | 0x01; //CS02..00[2..1]=1 =1;
 OCR0=80;//31%-  .
 
// *****  1 (16 )-  PWM (     )
 TCCR1A=0x02  //WGM11_WGM10 = 2[1..0]
      | 0x80 //COM1A(1..0)[7..6]=2;
      | 0x20; //COM1B(1..0)[5..4]=2;
 TCCR1B=0x18  //WGM1(3:2)=[4..3]=3;
      | 0x01; // ClkDiv[2..0]=1
 OCR1A=TIMER_PERIOD/2;//    50%
 OCR1B=TIMER_PERIOD/2;//    50%
 ICR1=TIMER_PERIOD;//  -  2  (7)
 //  -  COM1A(1..0)[7..6]=2; TCCR1A |= 0x80;
 //  -  COM1A(1..0)[7..6]=0;TCCR1A &= 0x3f; 
 TCCR1A &= 0x3f;// 
 TIMSK |= 1<<TOIE1;//     -  ICR1
//  TIMSK = 0x14;

// ********* Timer 2 init -   DsReset
 TCCR2=0x40 //WGM1[3]=0 WGM0[6]=1 CTC mode;
      | 0x00  //COM01[5]=0  COM00[4]=0     ;
      | 0x00; //CS02..00[2..1]=3 =1/32; 1  = 4.34  -  - 
 OCR2=111;// 
 TIMSK |= 1<<OCIE2;//  
//   TCCR2 &=~0x07 -  CLK.   
//   TCCR2 |= 0x03
//   - TCNT2
//   480  -> 111
//   70  ->16
//   410  -> 94  
   
//   INT1   
 MCUCR |= 0x080;
 GICR |= 1<<INT1;
 
 // ******* I2C init
 //TWBR=16;//  
 //TWCR=(1<<TWINT) | (1<<TWEN)|(1<<TWSTO);// |(1<<TWIE) // .   ASK(TWEA)
 // TWI(TWEN)    
 //TWSR=0;//TWPS=0(Prescaler=1)//  -   
 //TWDR=0;//  -    
 //TWAR=2;// 1,   0 - //   slave mode -  

 InitRS232();
 
 // *********** Variables init
 Tim_Flg=0;
 tim_cnt=TIMER_PERIOD;
 StartCommandFlg=0;
 RecBufCnt=0;
 pRecBuf=RecBuff;
 NumReceive=0;
 InitRS_Flg=0;

 AdcMultiplex=0;
 AdcCycleFlg=0;
 FirstAdcBits=1;
 AdcNumCyclesCnt=ADC_NUM_CYCLES;
 AdcCycleFlg=0;
 AdcOuFlg=0;

 KeyFlg=0;OutKey=0;GblOutKey=0;
 
 Int1Flg=0;
 PwmState=0;
 PwmCnt=0;
 for(i=0;i<4;i++) PwmSetValue(i, 0);
 PwmSetValue(1, 50);//,   
 PwmSet(PwmState);// -   

 InitLCD();

 DsResetState=0;
 DsResetResult=0;
 ResetReadyFlg=0; 
 DsNumUnits=0;
 for(i=0;i<DS_MAX_UNITS;i++) DsData[i]=0;
 sprintf(DString[0],"!         ");
 sprintf(DString[1]," DS18...   ");
 RefreshLCD();
 DsNumUnits=Ds_Scan();
 sprintf(DString[1]," %1d DS18  ",DsNumUnits);
 RefreshLCD();
 
 __enable_interrupt();// 
  
  // 
 asm("sbi 0x06,6");//ADCSRA=0x06;   ADSC=6;
 
//  
//Main Loop
loop:
 //  
  if(KeyFlg)
  {GblOutKey=OutKey;
   KeyFlg=0;
   SetBeep();
   // -   
   //............
    if(!TmpFlg)//     
    {TmpFlg=1;
     TmpKey=GblOutKey;
    };
  };
  
  if(Tim_Flg!=0)//    ( 1 )
     {Tim_Flg=0;
      
      if(AdcOuFlg)//     -  
        {for(i=0;i<ADC_NUM_CHAN;i++) Glob_AdcOutData[i]=AdcOutData[i];
         AdcOuFlg=0;
        };

      // DS18
      for(i=0;i<DsNumUnits;i++)
        {DsTimReset(); DsData[i]=Ds_Rd_Data(i);};
      DsTimReset();
      Ds_Wr_Byte(DS_SCIP_ROM);
      Ds_Wr_Byte(DS_START_CONV);

      //   (+)/DS18  5 
      //  -    DS18 -  5 
      ShowCnt++;
      if(ShowCnt>5)
        {if(ShowState==0) //  (+)
           {sprintf(DString[0],"A0=%4d A1=%4d ",Glob_AdcOutData[0]>>5,Glob_AdcOutData[1]>>5);
            sprintf(DString[1],"A2=%4d A3=%4d ",Glob_AdcOutData[2]>>5,Glob_AdcOutData[3]>>5);
            if(TmpFlg)
             {TmpFlg=0;
              DString[0][15]=TmpKey+'0';
             };
           };
         if(ShowState==1) //   DS18
           {for(i=0;i<DS_MAX_UNITS;i++)
             {if(i<DsNumUnits)
                {float f=(float)DsData[i]*0.0625;
                 if((f < 100.0) && (f >= 0.0)) sprintf(&DString[i>>1][8*(i&0x01)],"D%1d=%5.2f",i,f);
                 else sprintf(&DString[i>>1][8*(i&0x01)],"D%1d=%5.1f",i,f);
                }
              else
                sprintf(&DString[i>>1][8*(i&0x01)],"D%1d=-----",i);
             };
           };
         RefreshLCD();
         
         ShowState++;
         ShowCnt=0;
        };//End if(ShowCnt>5)
      
    if(ShowState>1) ShowState=0;
      
    //     1  (0)
    PwmTestVal+=10;
    if(PwmTestVal>100) PwmTestVal=0;
    PwmSetValue(0,PwmTestVal);
   };//End if(Tim_Flg!=0)
   
/*
//   RS-232.  -  ,         
//CommandCode=(RecBuff[0]>>4) & 0x0f; NumBytes=(RecBuff[0] & 0x0f)-1 ( -CRS,  );
 if(StartCommandFlg && TransmitEndFlg)
	{//unsigned char __eeprom *pEBuf;
     unsigned short int iData,iData1;
     
	// if(StartCommandFlg > 1) SetBeep();//Error -   -  ,   
     	//
	 	//0-     -  - 22 .  -    2 (20).  16 float MidTmpAdcData[0..4],  - CRS
	    //8-  .   -  ,  -   2- ,  -CRS.     =3,  -5;
		//-  (0 ) 
     
	    //9-  PWM.   -   (0..5),
        //  -   (0..3),
        // -      ,
        // -   2- ,  -CRS.
        //    =6,  -8;
        //  0 ->  PWM = 1 ;
        //   -  ; 
        //  >=  ->    1;
		//-  (0 ) 
    
     FlashLed();
	 switch( ((*RecBuff)>>4) &0x0f)
		{case 0://0-    
				TxBuf[0]=(unsigned char) sizeof(float)*5; //   -2// CRS  
                //memcpy(&TxBuf[1],&MidTmpAdcData[0],sizeof(float)*5);
                CRST=0;
                for(i=0;i<=TxBuf[0];i++) CRST+=TxBuf[i];
                TxBuf[TxBuf[0]+1]=255-CRST;
                TransmitBuff(TxBuf[0]+2, TxBuf);
				break;
         case 1://          
                //FlashLed();
               / * iData=ReadDigTerm(RecBuff[1]&0x03);
                TxBuf[0]=2;
                TxBuf[1]=(char)(iData>>8);
                TxBuf[2]=((char)iData)&0xff;
                CRST=0;
                for(i=0;i<=TxBuf[0];i++) CRST+=TxBuf[i];
                TxBuf[TxBuf[0]+1]=255-CRST;
                TransmitBuff(TxBuf[0]+2, TxBuf);
                * /
                break;
          
	 	 case 8://8-  .   -  ,  -   2- ,  -CRS.     =3,  -5;
			 	//- 1  
                //FlashLed();
                / *iData=(unsigned short int)RecBuff[2]+(((unsigned short int)RecBuff[3])<<8);// *((float *) (RecBuff+2));
                //FlashLed();
                WriteDac(RecBuff[1],iData);
			    TxBuf[0]=0;//    CRS  
	 			TxBuf[1]=0xff;
	 			TransmitBuff(2, TxBuf);
                * /
				break;
         case 9://0-  PWM
                iData=(unsigned short int)RecBuff[3]+(((unsigned short int)RecBuff[4])<<8);// *((float *) (RecBuff+2));
                iData1=(unsigned short int)RecBuff[5]+(((unsigned short int)RecBuff[6])<<8);// *((float *) (RecBuff+2));
                Timer1Set(RecBuff[1],iData,iData1,RecBuff[2],0);
                PwmPer=iData;PwmLen=iData1;
			    TxBuf[0]=0;//    CRS  
	 			TxBuf[1]=0xff;
	 			TransmitBuff(2, TxBuf);
                break;
		 default:SetBeep();
		    	//sprintf(G_str,"RS ComError");
   				//WrIndString(7,0,strlen(G_str),G_str,1,255);
		};
    
 	 //while(!TransmitEndFlg);
 	 StartCommandFlg=0;
	};// End if(StartCommandFlg!=0)
 */
 goto loop;	
}
